'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var fs = require('fs');
var path = require('path');
var helper = require('../../../lib/utils/helper');
var Package = require('../../../lib/utils/package');
var loading = require('../../../lib/utils/loading');
var log = require('../../../lib/utils/log');

module.exports = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(packages) {
        var pkgs, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, pkg, rows, _loop, i, _ret;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        if (!packages.length) this.showHelp();

                        loading('正在查找，请耐心等待...');

                        pkgs = {};
                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context.prev = 6;
                        _iterator = helper.aliasNames(packages)[Symbol.iterator]();

                    case 8:
                        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                            _context.next = 19;
                            break;
                        }

                        pkg = _step.value;
                        _context.t0 = pkg;
                        _context.next = 13;
                        return Package.getLatest(pkg);

                    case 13:
                        _context.t1 = _context.sent;
                        _context.t2 = [];
                        pkgs[pkg] = {
                            name: _context.t0,
                            version: _context.t1,
                            locals: _context.t2
                        };

                    case 16:
                        _iteratorNormalCompletion = true;
                        _context.next = 8;
                        break;

                    case 19:
                        _context.next = 25;
                        break;

                    case 21:
                        _context.prev = 21;
                        _context.t3 = _context['catch'](6);
                        _didIteratorError = true;
                        _iteratorError = _context.t3;

                    case 25:
                        _context.prev = 25;
                        _context.prev = 26;

                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }

                    case 28:
                        _context.prev = 28;

                        if (!_didIteratorError) {
                            _context.next = 31;
                            break;
                        }

                        throw _iteratorError;

                    case 31:
                        return _context.finish(28);

                    case 32:
                        return _context.finish(25);

                    case 33:

                        scan(process.cwd(), pkgs);

                        loading.close();

                        rows = [];

                        rows.push(`| Package | Current | Latest | Location |`);
                        rows.push(`| ------- | ------: | -----: | -------- |`);

                        _loop = function _loop(i) {
                            if (!pkgs.hasOwnProperty(i)) return 'continue';
                            var pkg = pkgs[i];
                            var version = pkg.version ? `<green>${pkg.version}</green>` : `<gray>-</gray>`;
                            if (!pkg.locals.length) {
                                rows.push(`| <gray>${pkg.name}</gray> | <gray>-</gray> | ${version} | <gray>-</gray> |`);
                            } else {
                                pkg.locals.forEach(function (p) {
                                    var name = pkg.version === p.version ? `<cyan>${pkg.name}</cyan>` : `<red>${pkg.name}</red>`;
                                    var location = path.relative(process.cwd(), p.location);
                                    rows.push(`| ${name} | ${p.version} | ${version} | ${location} |`);
                                });
                            }
                        };

                        _context.t4 = _regenerator2.default.keys(pkgs);

                    case 40:
                        if ((_context.t5 = _context.t4()).done) {
                            _context.next = 47;
                            break;
                        }

                        i = _context.t5.value;
                        _ret = _loop(i);

                        if (!(_ret === 'continue')) {
                            _context.next = 45;
                            break;
                        }

                        return _context.abrupt('continue', 40);

                    case 45:
                        _context.next = 40;
                        break;

                    case 47:

                        log('\n');
                        log(rows.join('\n'));
                        log('\n');

                    case 50:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[6, 21, 25, 33], [26,, 28, 32]]);
    }));

    return function (_x) {
        return _ref.apply(this, arguments);
    };
}();

function scan(dir, pkgs) {
    fs.readdirSync(dir, pkgs).forEach(function (name) {
        var fullPath = path.resolve(dir, name);
        if (fs.lstatSync(fullPath).isDirectory()) {
            helper.safeRun(function () {
                var pkg = fs.readFileSync(path.resolve(fullPath, 'package.json'), 'utf8');
                pkg = JSON.parse(pkg);

                if (pkgs[pkg.name]) {
                    pkgs[pkg.name].locals.push({
                        version: pkg.version,
                        location: fullPath
                    });
                }
            });

            scan(fullPath, pkgs);
        }
    });
}