'use strict';

var configs = require('../../../lib/configs');
var shell = require('../../../lib/utils/shell');

module.exports = function (help) {
    var args = process.argv.slice(2);
    if (args.length <= 1) {
        var info = shell.spawn(configs.npm, ['-l'], 1);
        var startFlag = 'where <command> is one of:'; // npm5以下为<cmd>
        var endFlag = '\nnpm <command> -h     quick help on'; // npm5以下为<cmd>
        var start = info.indexOf(startFlag) + startFlag.length;
        var end = info.indexOf(endFlag);
        var more = info.substring(start, end);
        more = more.replace(/npm/g, 'nbm');

        help = help + '\n\n\n  <u>更多命令</u>' + more;

        return help;
    } else {
        var _info = shell.spawn(configs.npm, args, 1);
        var _help = _info.replace(/^\n+|\n+$/g, '');
        _help = _help.replace(/npm/g, 'nbm');
        _help = _help.split('\n').map(function (line) {
            return '    ' + line;
        }).join('\n');

        return '\n' + _help + '\n';
    }
};