'use strict';

var npm = require('../../../lib/utils/npm');
var yarn = require('../../../lib/utils/yarn');
var helper = require('../../../lib/utils/helper');
var log = require('../../../lib/utils/log');
var Package = require('../../../lib/utils/package');

module.exports = function () {
    var packages = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    if (!options.global && !Package.hasPackageJSON()) {
        log.error('当前目录不存在package.json文件');
        return false;
    }

    packages = helper.aliasNames(packages);

    if (yarn.isUseYarn(options)) {
        yarn.install(packages, options);
    } else {
        npm.install(packages, options);
    }
};